Subject: Re: [PATCH RFCv1 1/3] PCI: Allow ATS to be always on for CXL.cache capable devices

From: Jason Gunthorpe <[email-masked]>
Date: Thu, 19 Feb 2026 13:41:39 -0400

On Thu, Feb 19, 2026 at 08:53:19AM -0800, Nicolin Chen wrote:
> The thing is that those driver_managed_dma callbacks don't call
> iommu_device_use_default_domain(). So, the iommu core loses the
> trigger to switch domain from BLOCKED/empty-DMA to DMA/IDENTITY.

But they don't use DMA API at all so it doesn't matter to them.

Your issue is that BLOCKED breaks MSI on ARM. That is fixed by using
an empty-DMA API domain as default.

What is missing is to bring back the IDENTITY performance optimization
in a secure way.

Jason